#!/usr/bin/python

import math

class figure:
  """
  classe de base pour des figures geometriques
  """
  def __init__(self, color):
    self.color = color
  def id(self):
    """
    return a string describing the figure
    """
    return "figure: " + self.color

class cercle(figure):
  """
  classe cercle, herite de figure
  """ 
  def __init__(self, color, rayon):
    self.color = color
    self.rayon = rayon
  def surface(self):
    return math.pi * math.pow(self.rayon,2)
  def id(self):
    return "cercle: " + self.color + ", " + str(self.rayon)

class rectangle(figure):
  """
  classe rectangle, herite de figure
  """
  def __init__(self, color, a, b):
    self.color = color
    self.a = a
    self.b = b
  def surface(self):
    return self.a * self.b
  def id(self):
    return "rectangle: "+self.color+", "+ str(self.a)+ ", "+ str(self.b)

class carre(rectangle):
  """
  classe carre, herite de rectangle
  """
  def __init__(self, color, a):
    self.color = color
    self.a = a
    self.b = a
  def id(self):
    return "carre: "+self.color+", "+ str(self.a)

class dessin:
  """
  classe dessin, conteneur de figures
  """
  def __init__(self):
    self.num = 0
    self.dessin = []
  def add(self, figure):
    self.num = self.num + 1
    self.dessin.append(figure)
  def list(self):
    for i in self.dessin:
      print i.id()

if __name__ == "__main__":
  d = dessin()
  f1 = figure('red')
  d.add(f1)
  f2 = figure('green')
  d.add(f2)
  f3 = figure('yellow')
  d.add(f3)
  c1 = cercle('red', 3)
  d.add(c1)
  r1 = rectangle('blue', 2, 3)
  d.add(r1)
  ca = carre('orange', 4)
  d.add(ca)
  print "d.num:", d.num
  print "d:"
  d.list()
  print "f1.color:", f1.color
  f1.color = 'violet'
  print "f1.color:", f1.color
  print "c1.surface():", c1.surface()
  print "ca.surface():", ca.surface()
  print f1.__doc__
  print c1.__doc__
  print r1.__doc__
  print ca.__doc__
  print d.__doc__
  print d
